#!/usr/local/bin/perl -w


$ref_hash = { # note the brackets!
    lunch => 'noon',
    dinner => 'six pm'
    };

sub test {
    return "test";
}


$c = 3;
$ref_scalar = \$c;
# rightmost $ dereferences, leftmost $ indicates scalar value
$value = $$ref_scalar; # $value is 3
print ("$value\n");
# could also write
$value = ${$ref_scalar}; # same as above
print ("$value\n");
$ref_array = [1, 2, 3];
$$ref_array[2] = 4;
print("@$ref_array\n"); # prints 1 2 4<newline>
# the following produces the same result
# it says $ref_array is a reference;
# dereference it and return the second element
# of the result (it always defaults to a scalar
# context -- i.e., always returns a scalar value)
$ref_array->[2] = 4;
print("@$ref_array\n"); # prints 1 2 4<newline>
$$ref_hash{'breakfast'} = 'seven am';
@meals = keys(%$ref_hash); 
print("@meals\n");
$ref_sub = \&test;
$c = &$ref_sub(2);  # calls a sub 
print("$c\n");


$a = 1;
$b = 2;
$c = 3;

    $ref_array = [$a, $b, $c];
    # referenence to an unnamed array consisting of
    # of the values of $a, $b, and $c at the time of creation


$$ref_array[0] = 100;
print("@$ref_array\n");
print("$a\n");

    # contrast with
    @array_of_refs = \($a, $b, $c);
    # a three element array containing references 
    # to $a, $b, and $c
    # same as
    # @array_of_refs = (\$a, \$b, $\c);

${$array_of_refs[0]} = 100;
foreach $ref (@array_of_refs) {
    print ($$ref, " ");
}
print("\n");
print("$a\n");


